diff --git a/web/migrations/versions/50aad68f99c2_.py b/web/migrations/versions/50aad68f99c2_.py
new file mode 100644
index 0000000..f8c97f2
--- /dev/null
+++ b/web/migrations/versions/50aad68f99c2_.py
@@ -0,0 +1,82 @@
+
+"""Added service field option in server table (RM#3140)
+
+Revision ID: 50aad68f99c2
+Revises: 02b9dccdcfcb
+Create Date: 2018-03-07 11:53:57.584280
+
+"""
+from pgadmin.model import db
+
+
+# revision identifiers, used by Alembic.
+revision = '50aad68f99c2'
+down_revision = '02b9dccdcfcb'
+branch_labels = None
+depends_on = None
+
+
+def upgrade():
+        # To Save previous data
+        db.engine.execute("ALTER TABLE server RENAME TO server_old")
+
+        # With service file some fields won't be mandatory as user can provide
+        # them using service file. Removed NOT NULL constraint from few columns
+        db.engine.execute("""
+            CREATE TABLE server (
+                id	INTEGER NOT NULL,
+                user_id	INTEGER NOT NULL,
+                servergroup_id	INTEGER NOT NULL,
+                name	VARCHAR(128) NOT NULL,
+                host	VARCHAR(128),
+                port	INTEGER NOT NULL CHECK(port >= 1024 AND port <= 65534),
+                maintenance_db	VARCHAR(64),
+                username	VARCHAR(64) NOT NULL,
+                password	VARCHAR(64),
+                role	VARCHAR(64),
+                ssl_mode	VARCHAR(16) NOT NULL CHECK(ssl_mode IN
+                    ( 'allow' , 'prefer' , 'require' , 'disable' ,
+                      'verify-ca' , 'verify-full' )
+                ),
+                comment	VARCHAR(1024),
+                discovery_id	VARCHAR(128),
+                hostaddr	TEXT(1024),
+                db_res	TEXT,
+                passfile	TEXT,
+                sslcert	TEXT,
+                sslkey	TEXT,
+                sslrootcert	TEXT,
+                sslcrl	TEXT,
+                sslcompression	INTEGER DEFAULT 0,
+                bgcolor TEXT(10),
+                fgcolor TEXT(10),
+                PRIMARY KEY(id),
+                FOREIGN KEY(user_id) REFERENCES user(id),
+                FOREIGN KEY(servergroup_id) REFERENCES servergroup(id)
+            )
+        """)
+
+        # Copy old data again into table
+        db.engine.execute("""
+        INSERT INTO server (
+            id,user_id, servergroup_id, name, host, port, maintenance_db,
+            username, ssl_mode, comment, password, role, discovery_id,
+            hostaddr, db_res, passfile, sslcert, sslkey, sslrootcert, sslcrl,
+            bgcolor, fgcolor
+        ) SELECT
+            id,user_id, servergroup_id, name, host, port, maintenance_db,
+            username, ssl_mode, comment, password, role, discovery_id,
+            hostaddr, db_res, passfile, sslcert, sslkey, sslrootcert, sslcrl,
+            bgcolor, fgcolor
+        FROM server_old""")
+
+        # Remove old data
+        db.engine.execute("DROP TABLE server_old")
+
+        # Add column for Service ID
+        db.engine.execute(
+            'ALTER TABLE server ADD COLUMN service TEXT'
+        )
+
+def downgrade():
+    pass
diff --git a/web/pgadmin/browser/server_groups/servers/__init__.py b/web/pgadmin/browser/server_groups/servers/__init__.py
index dfa9d62..fecb66d 100644
--- a/web/pgadmin/browser/server_groups/servers/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/__init__.py
@@ -478,7 +478,8 @@ class ServerNode(PGChildNodeView):
             'sslcrl': 'sslcrl',
             'sslcompression': 'sslcompression',
             'bgcolor': 'bgcolor',
-            'fgcolor': 'fgcolor'
+            'fgcolor': 'fgcolor',
+            'service': 'service'
         }
 
         disp_lbl = {
@@ -515,7 +516,7 @@ class ServerNode(PGChildNodeView):
         if connected:
             for arg in (
                     'host', 'hostaddr', 'port', 'db', 'username', 'sslmode',
-                    'role'
+                    'role', 'service'
             ):
                 if arg in data:
                     return forbidden(
@@ -663,7 +664,8 @@ class ServerNode(PGChildNodeView):
                 'sslrootcert': server.sslrootcert if is_ssl else None,
                 'sslcrl': server.sslcrl if is_ssl else None,
                 'sslcompression': True if is_ssl and server.sslcompression
-                else False
+                else False,
+                'service': server.service if server.service else None
             }
         )
 
@@ -672,18 +674,22 @@ class ServerNode(PGChildNodeView):
         """Add a server node to the settings database"""
         required_args = [
             u'name',
-            u'host',
             u'port',
-            u'db',
-            u'username',
             u'sslmode',
-            u'role'
+            u'username'
         ]
 
         data = request.form if request.form else json.loads(
             request.data, encoding='utf-8'
         )
 
+        # Some fields can be provided with service file so they are optional
+        if 'service' in data and not data['service']:
+            required_args.extend([
+                u'host',
+                u'db',
+                u'role'
+            ])
         for arg in required_args:
             if arg not in data:
                 return make_json_response(
@@ -711,29 +717,26 @@ class ServerNode(PGChildNodeView):
         try:
             server = Server(
                 user_id=current_user.id,
-                servergroup_id=data[u'gid'] if u'gid' in data else gid,
-                name=data[u'name'],
-                host=data[u'host'],
-                hostaddr=data[u'hostaddr'] if u'hostaddr' in data else None,
-                port=data[u'port'],
-                maintenance_db=data[u'db'],
-                username=data[u'username'],
-                ssl_mode=data[u'sslmode'],
-                comment=data[u'comment'] if u'comment' in data else None,
-                role=data[u'role'] if u'role' in data else None,
+                servergroup_id=data.get('gid', gid),
+                name=data.get('name'),
+                host=data.get('host', None),
+                hostaddr=data.get('hostaddr', None),
+                port=data.get('port'),
+                maintenance_db=data.get('db', None),
+                username=data.get('username'),
+                ssl_mode=data.get('sslmode'),
+                comment=data.get('comment', None),
+                role=data.get('role', None),
                 db_res=','.join(data[u'db_res'])
-                if u'db_res' in data
-                else None,
-                sslcert=data['sslcert'] if is_ssl else None,
-                sslkey=data['sslkey'] if is_ssl else None,
-                sslrootcert=data['sslrootcert'] if is_ssl else None,
-                sslcrl=data['sslcrl'] if is_ssl else None,
+                if u'db_res' in data else None,
+                sslcert=data.get('sslcert', None),
+                sslkey=data.get('sslkey', None),
+                sslrootcert=data.get('sslrootcert', None),
+                sslcrl=data.get('sslcrl', None),
                 sslcompression=1 if is_ssl and data['sslcompression'] else 0,
-                bgcolor=data['bgcolor'] if u'bgcolor' in data
-                else None,
-                fgcolor=data['fgcolor'] if u'fgcolor' in data
-                else None
-
+                bgcolor=data.get('bgcolor', None),
+                fgcolor=data.get('fgcolor', None),
+                service=data.get('service', None)
             )
             db.session.add(server)
             db.session.commit()
@@ -930,7 +933,7 @@ class ServerNode(PGChildNodeView):
         if 'password' not in data:
             conn_passwd = getattr(conn, 'password', None)
             if conn_passwd is None and server.password is None and \
-                    server.passfile is None:
+                    server.passfile is None and server.service is None:
                 # Return the password template in case password is not
                 # provided, or password has not been saved earlier.
                 return make_json_response(
diff --git a/web/pgadmin/browser/server_groups/servers/static/js/server.js b/web/pgadmin/browser/server_groups/servers/static/js/server.js
index 9932808..bedb38d 100644
--- a/web/pgadmin/browser/server_groups/servers/static/js/server.js
+++ b/web/pgadmin/browser/server_groups/servers/static/js/server.js
@@ -665,6 +665,7 @@ define('pgadmin.node.server', [
           sslkey: undefined,
           sslrootcert: undefined,
           sslcrl: undefined,
+          service: undefined,
         },
         // Default values!
         initialize: function(attrs, args) {
@@ -841,12 +842,18 @@ define('pgadmin.node.server', [
             var passfile = m.get('passfile');
             return !_.isUndefined(passfile) && !_.isNull(passfile);
           },
+        },{
+          id: 'service', label: gettext('Service ID'), type: 'text',
+          mode: ['properties', 'edit', 'create'], disabled: 'isConnected',
+          group: gettext('Advanced'),
         }],
         validate: function() {
           var err = {},
             errmsg,
             self = this;
 
+          var service_id = this.get('service');
+
           var check_for_empty = function(id, msg) {
             var v = self.get(id);
             if (
@@ -903,26 +910,41 @@ define('pgadmin.node.server', [
           }
           check_for_empty('name', gettext('Name must be specified.'));
 
-          if (check_for_empty(
-            'host', gettext('Either Host name or Host address must be specified.')
-          ) && check_for_empty('hostaddr', gettext('Either Host name or Host address must be specified.'))){
-            errmsg = errmsg || gettext('Either Host name or Host address must be specified');
+          // If no service id then only check
+          if (
+              _.isUndefined(service_id) || _.isNull(service_id) ||
+              String(service_id).replace(/^\s+|\s+$/g, '') == ''
+            ) {
+            if (check_for_empty(
+              'host', gettext('Either Host name or Host address must be specified.')
+            ) && check_for_empty('hostaddr', gettext('Either Host name or Host address must be specified.'))){
+              errmsg = errmsg || gettext('Either Host name or Host address must be specified');
+            } else {
+              errmsg = undefined;
+              delete err['host'];
+              delete err['hostaddr'];
+            }
+
+            check_for_empty(
+              'db', gettext('Maintenance database must be specified.')
+            );
+            check_for_valid_ip(
+              'hostaddr', gettext('Host address must be valid IPv4 or IPv6 address.')
+            );
+            check_for_valid_ip(
+              'hostaddr', gettext('Host address must be valid IPv4 or IPv6 address.')
+            );
           } else {
-            errmsg = undefined;
-            delete err['host'];
-            delete err['hostaddr'];
+            _.each(['host', 'hostaddr', 'db'], (item) => {
+              self.errorModel.unset(item);
+            });
           }
 
           check_for_empty(
-            'db', gettext('Maintenance database must be specified.')
-          );
-          check_for_empty(
             'username', gettext('Username must be specified.')
           );
           check_for_empty('port', gettext('Port must be specified.'));
-          check_for_valid_ip(
-            'hostaddr', gettext('Host address must be valid IPv4 or IPv6 address.')
-          );
+
           this.errorModel.set(err);
 
           if (_.size(err)) {
diff --git a/web/pgadmin/browser/server_groups/servers/tests/test_add_server_with_service_id.py b/web/pgadmin/browser/server_groups/servers/tests/test_add_server_with_service_id.py
new file mode 100644
index 0000000..3b03d49
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/tests/test_add_server_with_service_id.py
@@ -0,0 +1,47 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import json
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+
+
+class ServersWithServiceIDAddTestCase(BaseTestGenerator):
+    """ This class will add the servers under default server group. """
+
+    scenarios = [
+        # Fetch the default url for server object
+        (
+            'Default Server Node url', dict(
+                url='/browser/server/obj/'
+            )
+        )
+    ]
+
+    def setUp(self):
+        pass
+
+    def runTest(self):
+        """ This function will add the server under default server group."""
+        url = "{0}{1}/".format(self.url, utils.SERVER_GROUP)
+        # Add service name in the config
+        self.server['service'] = "TestDB"
+        response = self.tester.post(
+            url,
+            data=json.dumps(self.server),
+            content_type='html/json'
+        )
+        self.assertEquals(response.status_code, 200)
+        response_data = json.loads(response.data.decode('utf-8'))
+        self.server_id = response_data['node']['_id']
+
+    def tearDown(self):
+        """This function delete the server from SQLite """
+        utils.delete_server_with_api(self.tester, self.server_id)
diff --git a/web/pgadmin/model/__init__.py b/web/pgadmin/model/__init__.py
index 674f945..11bc9f0 100644
--- a/web/pgadmin/model/__init__.py
+++ b/web/pgadmin/model/__init__.py
@@ -107,13 +107,13 @@ class Server(db.Model):
         nullable=False
     )
     name = db.Column(db.String(128), nullable=False)
-    host = db.Column(db.String(128), nullable=False)
+    host = db.Column(db.String(128), nullable=True)
     hostaddr = db.Column(db.String(128), nullable=True)
     port = db.Column(
         db.Integer(),
         db.CheckConstraint('port >= 1024 AND port <= 65534'),
         nullable=False)
-    maintenance_db = db.Column(db.String(64), nullable=False)
+    maintenance_db = db.Column(db.String(64), nullable=True)
     username = db.Column(db.String(64), nullable=False)
     password = db.Column(db.String(64), nullable=True)
     role = db.Column(db.String(64), nullable=True)
@@ -144,6 +144,7 @@ class Server(db.Model):
     )
     bgcolor = db.Column(db.Text(10), nullable=True)
     fgcolor = db.Column(db.Text(10), nullable=True)
+    service = db.Column(db.Text(), nullable=True)
 
 
 class ModulePreference(db.Model):
